from django import template
from django.utils.safestring import mark_safe

from seller.models import Category as sel_category
from seller.models import SubCategory as sel_subcategory
from kisan.models import Category as kisan_category
from kisan.models import SubCategory as kisan_subcategory


register = template.Library()

@register.simple_tag
def sellernavigation():
    categories = sel_category.objects.filter(is_active=True)
    items_li, sub_li, cat_item = "", "", ""
    for i in categories:
        items_li = """<li class="hassubs"> <a href="/seller/{}/{}">{}
                            <i class="fas fa-chevron-down"></i></a><ul>""".format(i.cat_title, i.id, i.cat_title)
        sub_category = sel_subcategory.objects.filter(category=i)
        for j in sub_category:
            sub_li += """<li> <a href="/seller/{}/{}/{}">{}
            <i class="fas fa-chevron-down"></i></a></li>""".format(i.cat_title, j.sub_title, j.id, j.sub_title)
        cat_item += str(items_li) + str(sub_li) + "</ul></li>"
        sub_li = ""
    return mark_safe(cat_item)

@register.simple_tag
def homenavigation():
    categories = kisan_category.objects.filter(is_active=True)
    items_li, sub_li, cat_item = "", "", ""
    for i in categories:
        items_li = """<li class="hassubs"> <a href="/home/{}/{}">{}
                            <i class="fas fa-chevron-down"></i></a><ul>""".format(i.cat_title, i.id, i.cat_title)
        sub_category = kisan_subcategory.objects.filter(category=i)
        for j in sub_category:
            sub_li += """<li> <a href="/home/{}/{}/{}">{}
            <i class="fas fa-chevron-down"></i></a></li>""".format(i.cat_title, j.sub_title, j.id, j.sub_title)
        cat_item += str(items_li) + str(sub_li) + "</ul></li>"
        sub_li = ""
    return mark_safe(cat_item)

# {% for category in categories %}
#    <li class="hassubs"> <a href="/seller/{{category}}/{{category.id}}">{{category}}<i class="fas fa-chevron-down"></i></a>
#         <ul>
#         {% for subcat in sub_category %}
#             {% if subcat.category == category %}
#                 <li> <a href="/seller/{{category}}/{{subcat.sub_title}}/{{subcat.id}}">{{subcat.sub_title}}<i class="fas fa-chevron-down"></i></a></li>
#             {% endif %}
#         {% endfor %}
#         </ul>
#    </li>
# {% endfor %}
#
#
# <li class="hassubs"> <a href="/seller/{{category}}/{{category.id}}">{{category}}<i class="fas fa-chevron-down"></i></a><ul>{}</ul></li>
#
# < li > < a href = "/seller/{{category}}/{{subcat.sub_title}}/{{subcat.id}}" > {{subcat.sub_title}} < i class ="fas fa-chevron-down" > < / i > < / a > < / li >
#
#
# @register.simple_tag
# def categories():
#     items = Category.objects.filter(is_active=True).order_by('title')
#     items_li = ""
#     for i in items:
#         items_li += """<li><a href="/category/{}">{}</a></li>""".format(i.slug, i.title)
#     return mark_safe(items_li)
#
# @register.simple_tag
# def categories_mobile():
#     items = Category.objects.filter(is_active=True).order_by('title')
#     items_li = ""
#     for i in items:
#         items_li += """<li class="item-menu-mobile"><a href="/category/{}">{}</a></li>""".format(i.slug, i.title)
#     return mark_safe(items_li)
#
#
# @register.simple_tag
# def categories_li_a():
#     items = Category.objects.filter(is_active=True).order_by('title')
#     items_li_a = ""
#     for i in items:
#         items_li_a += """<li class="p-t-4"><a href="/category/{}" class="s-text13">{}</a></li>""".format(i.slug,
#                                                                                                          i.title)
#     return mark_safe(items_li_a)
#
#
# @register.simple_tag
# def categories_div():
#     """
#     section banner
#     :return:
#     """
#     items = Category.objects.filter(is_active=True).order_by('title')
#     items_div = ""
#     item_div_list = ""
#     for i, j in enumerate(items):
#         if not i % 2:
#             items_div += """<div class="block1 hov-img-zoom pos-relative m-b-30" style="border-radius: 5px;"><img style="border-radius: 5px; border-style: ridge;" src="/media/{}" alt="IMG-BENNER"><div class="block1-wrapbtn w-size2"><a href="/category/{}" class="flex-c-m size2 m-text2 bg3 hov1 trans-0-4" >{}</a></div></div>""".format(
#                 j.image, j.slug, j.title)
#         else:
#             items_div_ = """<div class="block1 hov-img-zoom pos-relative m-b-30" style="border-radius: 5px;"><img style="border-radius: 5px; border-style: ridge;" src="/media/{}" alt="IMG-BENNER"><div class="block1-wrapbtn w-size2"><a href="/category/{}" class="flex-c-m size2 m-text2 bg3 hov1 trans-0-4">{}</a></div></div>""".format(
#                 j.image, j.slug, j.title)
#             item_div_list += """<div class="col-sm-10 col-md-8 col-lg-4 m-l-r-auto">""" + items_div + items_div_ + """</div>"""
#             items_div = ""
#
#     return mark_safe(item_div_list)
