from django.shortcuts import render, redirect
from django.http import HttpResponse
from kisan.models import ProductData, SubCategory, Category, Rating
from accounts.models import SellerData, KisanData
from accounts.views import kisan_login_required,cust_login_required
from cart.models import PCart, Quantity, ContactCart, ContactList, CPCart
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from django.contrib import messages

# Create your views here.
def home(request):
    return render(request, 'homepage.html')


def get_subcategory(request):
    id = request.GET.get('id', '')
    result = list(SubCategory.objects.filter(category_id=int(id)).values('id', 'cat_title'))
    return HttpResponse(json.dumps(result), content_type="application/json")


def cat_view(request, cat_name, cat_id):
    sub_result = list(SubCategory.objects.filter(category=cat_id))
    return render(request, 'home/cat_view.html', {'subcategory': sub_result, 'cat_nm': cat_name})


def subcat_view(request, cat_name, subcat_name, subcat_id):
    prod_results = list(ProductData.objects.filter(subcategory_id=subcat_id))
    return render(request, 'home/subcat_view.html', {'product': prod_results, 'subcat_nm': subcat_name})


def browse(request):
    # p = ProductData.objects.all()
    sub_cat = SubCategory.objects.all()
    query_Set = Category.objects.all()
    page = request.GET.get('page', 1)
    paginator = Paginator(query_Set, 20)
    try:
        cat = paginator.page(page)
    except PageNotAnInteger:
        cat = paginator.page(1)
    except EmptyPage:
        cat = paginator.page(paginator.num_pages)
    return render(request, 'home/products_display.html', {'prods': 'p', 'categories': cat, 'sub_category': sub_cat})


def subcategory_product(request, object_id):
    query_Set = ProductData.objects.filter(subcategory=object_id).order_by('p_price')
    subcat_des = SubCategory.objects.get(id=object_id)
    sub_cat = SubCategory.objects.all()
    cat = Category.objects.all()
    page = request.GET.get('page', 1)
    paginator = Paginator(query_Set, 20)
    try:
        prod = paginator.page(page)
    except PageNotAnInteger:
        prod = paginator.page(1)
    except EmptyPage:
        prod = paginator.page(paginator.num_pages)
    return render(request, 'home/subcat_products_display.html', {'prods': prod, 'categories': cat, 'sub_category': sub_cat, 'subcat_des': subcat_des})


# def desc(request, object_id):
#     product = ProductData.objects.get(id=object_id)
#     sellers = SellerData.objects.all()
#     list_products = ProductData.objects.filter(p_name__icontains=product.p_name).order_by('p_price')
#     p1 = ProductData.objects.filter(id=list_products[0].id).values()
#     s = p1[0]['seller_name']
#     num_res1 = Rating.objects.filter(seller=s).count()
#     if num_res1 == 0:
#         co = 0
#         us = []
#     else:
#         co = Rating.objects.filter(seller=s).values()[0]['rate']
#         us1 = Rating.objects.get(seller=s)
#         us = us1.users.values_list()
#     if request.method == 'POST' and 'deleter' in request.POST:
#         Q = request.POST.get('quant', list_products[0].min_q)
#         num_res = PCart.objects.filter(user=request.user.email).count()
#         if num_res == 0:
#             p = PCart(user=request.user.email)
#             p.save()
#         q = Quantity(min_q=Q)
#         q.save()
#         p1 = PCart.objects.get(user__iexact=request.user.email)
#         p1.p_name.add(list_products[0])
#         p1.quant.add(q)
#         p1.save()
#     return render(request, 'home/product_description.html',
#                   {'data': product, 'listdata': list_products, 't': 0, 'co': co, 'us': us, 'seller': sellers})


def desc(request, object_id):
    product = ProductData.objects.get(id=object_id)
    sellers = SellerData.objects.all()
    list_products = ProductData.objects.filter(p_name__icontains=product.p_name).order_by('p_price')
    p1 = ProductData.objects.filter(id=list_products[0].id).values()
    s = p1[0]['seller_name']
    num_res1 = Rating.objects.filter(seller=s).count()
    if num_res1 == 0:
        co = 0
        us = []
    else:
        co = Rating.objects.filter(seller=s).values()[0]['rate']
        us1 = Rating.objects.get(seller=s)
        us = us1.users.values_list()
    if request.method == 'POST' and 'deleter' in request.POST:
        Q = request.POST.get('quant', list_products[0].min_q)
        num_res = CPCart.objects.filter(user=request.user.username).count()
        if num_res == 0:
            p = CPCart(user=request.user.username)
            p.save()
        q = Quantity(min_q=Q)
        q.save()
        p1 = CPCart.objects.get(user__iexact=request.user.username)
        p1.p_name.add(list_products[0])
        p1.quant.add(q)
        p1.save()
    return render(request, 'home/product_description.html',
                  {'data': product, 'listdata': list_products, 't': 0, 'co': co, 'us': us, 'seller': sellers})


def desc1(request, object_id):
    product = ProductData.objects.get(id=object_id)
    sellers = SellerData.objects.all()
    list_products = ProductData.objects.filter(p_name__icontains=product.p_name).order_by('p_price')
    p1 = ProductData.objects.filter(id=product.id).values()
    s = p1[0]['seller_name']
    num_res1 = Rating.objects.filter(seller=s).count()
    if num_res1 == 0:
        co = 0
    else:
        co = Rating.objects.filter(seller=s).values()[0]['rate']
    if request.method == 'POST' and 'deleter' in request.POST:
        Q = request.POST.get('quant', product.min_q)
        num_res = CPCart.objects.filter(user=request.user.username).count()
        if num_res == 0:
            p = CPCart(user=request.user.username)
            p.save()
        q = Quantity(min_q=Q)
        q.save()
        p1 = CPCart.objects.get(user__iexact=request.user.username)
        p1.p_name.add(list_products[0])
        p1.quant.add(q)
        p1.save()
    return render(request, 'home/product_description.html',
                  {'data': product, 'listdata': list_products, 't': 1, 'co': co, 'seller':sellers})

@cust_login_required
def kisan_contact(request, object_id, object_name):
    user_id = ProductData.objects.filter(id=object_id).values_list('s_username', flat=True)
    # seller = SellerData.objects.get(id=object_id, name=object_name)
    # contact_details = KisanData.objects.get(name=object_name)
    print(int(user_id[0]))
    contact_details = KisanData.objects.get(mobile=user_id[0])
    print(contact_details)
    # print(contact_details.name)
    if request.method == 'POST' and 'deleter' in request.POST:
        id = str(request.POST.get('seller_id'))
        name = str(request.POST.get('seller_name'))
        phone = int(request.POST.get('seller_mobile'))
        # print(name, phone)
        p = ContactCart.objects.get_or_create(user=request.user.username)
        # print(request.user.email)
        p1 = ContactList.objects.filter(s_name=name, s_mobile=phone)
        print(p1.values())
        if p1==True:
            p2 = ContactList.objects.create(s_id=id, s_name=name, s_mobile=phone)
            print(p2)

            p[0].contact_list.add(p2)
            messages.info(request, 'Added in contact list')
            # return redirect('/')
        else:
            p2 = ContactList.objects.create(s_id=id, s_name=name, s_mobile=phone)
            print(p2)
            p[0].contact_list.add(p2)
            messages.info(request, 'Contact already exist')
            # return redirect('/')
    num_res1 = Rating.objects.filter(seller=object_name).count()
    if num_res1 == 0:
        co = 0
    else:
        co = Rating.objects.filter(seller=s).values()[0]['rate']
    return render(request, 'home/contact_detail.html',
                  {'contact_details': contact_details, 'co': co})

