from django.db import models
from gst_field.modelfields import GSTField


# Create your models here.
class UserData(models.Model):
    name = models.CharField(max_length=100)
    email = models.EmailField(max_length=254)
    password = models.CharField(max_length=100)
    mobile = models.CharField(max_length=15)
    # dob = models.CharField(max_length=15)
    gst = GSTField(default='abc12345')
    comp_name = models.CharField(max_length=100, default='blank')
    address = models.TextField(max_length=200, default='blank')
    state = models.CharField(max_length=100, default='blank')
    pincode = models.CharField(max_length=8, default=12346)
    rating = models.IntegerField(default=0)
    otp = models.IntegerField(null=True, blank=True)
    activation_key = models.CharField(max_length=150, blank=True, null=True)

    def __str__(self):
        return str(self.id) + "-" + str(self.name)


class SellerData(models.Model):
    name = models.CharField(max_length=100)
    email = models.EmailField(max_length=254)
    password = models.CharField(max_length=100)
    mobile = models.CharField(max_length=15)
    gst = GSTField()
    comp_name = models.CharField(max_length=100)
    address = models.TextField(max_length=200)
    state = models.CharField(max_length=100)
    pincode = models.CharField(max_length=8)
    rating = models.IntegerField(default=0)
    otp = models.IntegerField(null=True, blank=True)
    activation_key = models.CharField(max_length=150, blank=True, null=True)

    def __str__(self):
        return str(self.id) + "-" + str(self.name)


class KisanData(models.Model):
    name = models.CharField(max_length=100)
    email = models.EmailField(max_length=254, null=True)
    password = models.CharField(max_length=100)
    mobile = models.CharField(max_length=12, unique=True)
    address = models.TextField(max_length=200)
    city = models.CharField(max_length=100)
    state = models.CharField(max_length=100)
    pincode = models.CharField(max_length=8)
    rating = models.IntegerField(default=0)
    otp = models.IntegerField(null=True, blank=True)
    activation_key = models.CharField(max_length=150, blank=True, null=True)

    def __str__(self):
        return str(self.id) + "-" + str(self.name)
